// C-Programm zur Bestimmung der Hufgkeit von Doppel-Zeichen im Text txt
// Entwicklungsumgebung Dev-C++ 4.9.9.2, frei ladbare GNU-Software
// Nur fr Experimentierzwecke
// Der Text txt kann durch beliebige andere Zeichenketten ersetzt werden
// 08.05.2007
// Textbeispiel: Walter Moers, "Die 13 1/2 Leben des Kpt'n Blaubr", Mein Leben in den Finsterbergen

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void main (void)
{
  int a, ia,i,ih, iha, j, k, sum, ntxt, nchc, nchcb, sum_zeichen[500], sum_zeichenb[500],f_hilf[500],fb_hilf[500];
  
  char b[2], ch, chcb[500], chc_hilf[500], chcb_hilf[500], *txt;
  
  unsigned char l1u, l2u;
  
  txt="\"Wissen\", brllte Professor Nachtigaller in den Klassenraum und ri dabei seine Augen auf, bis sie so gro wie Untertassen waren, \"Wissen ist Nacht!\" Das war ein Lehrsatz der Eydeetischen Philophysik, ein Fach, das nur an der Nachtschule gelehrt wurde. Professor Nachtigaller sagte fter solche Sachen, wahrscheinlich um uns aus der Fassung zu bringen. Es steckte Methode in diesen scheinbar sinnlosen Behauptungen. Bevor man dahinterkam, dass sie vllig blde waren, hatte man in alle mglichen Richtungen gedacht. Und das war genau das, was Professor Nachtigaller wollte: Wir sollten denken lernen, und zwar in mglichst viele verschiedenen Richtungen. In diesem Fall steckte allerdings eine gewisse Wahrheit in dem, was er gesagt hatte, denn Professor Nachtigaller war ein Eydeet. Eydeete sind die intelligentesten Wesen Zamoniens (und vermutlich der ganzen Welt, wenn nicht sogar des Universums): Bei normaler Beleuchtung haben sie einen Intelligenzquotienten von 4000, aber wenn es dunkel wird, steigert er sich ins Unvorstellbare. Daher halten sich Eydeete geren in mglichst finsteren Verhltnissen auf, und deshalb war Nachtigallers Nachtakademie in einem dsteren Hhlensystem in den Finsterbergen untergebracht. Professor Nachtigaller arbeitete in seiner Freizeit an einem System, Dunkelheit noch dunkler zu machen. Er hatte sich dafr eigens eine Dunkelkammer eingerichtet, die niemand auer ihm betreten durfte. Wir legten auch keinen groen Wert darauf, denn die Gerusche, die wir hrten, wenn wir gelegentlich an der Tr horchten, waren alles andere als einladend. Ein normaler Eydeet hat drei Gehirne, ein begabter vier, ein Eydeet mit Geniestatus fnf, Professor Nachtigaller hatte sieben. Eins davon befand sich im Kopf, vier wuchsen ihm aus der Schdelplatte, eins sa da, wo normalerweise die Milz ist, und wo das siebte Gehirn war, blieb ewiger Gegenstand der Spekulation seiner Schler.";
  
  ntxt=strlen(txt);
  printf("\n%s\t\t%d\n","Anzahl der Zeichen im Text:",ntxt);
  
  //Zeichenkette chcb der verschiedenen Doppel-Zeichen
  
  chcb[0]=txt[0];
  chcb[1]=txt[1];

   for(i=0;i<ntxt/2;i++) 
   { 
   b[0]= txt[2*i]; 
   b[1]= txt[2*i+1];
   
   nchcb=strlen(chcb);
   a=0;
   for(j=0;j<nchcb/2;j++)                                        
   if ((b[0]== chcb[2*j]) && (b[1]== chcb[2*j+1])) a=1;
   if (a==0) strcat(chcb,b);
    };
   nchcb=strlen(chcb)/2;
   
  printf("\n%s\n\n","Alle Doppelzeichen im Text:");
  // Ausgabe-Anpassung der Umlaute usw.:
  for (i=0;i<(2*nchcb);i++)
  {
      l1u= chcb[i];
      if(l1u==228) l1u=132; //
      if(l1u==246) l1u=148; //
      if(l1u==252) l1u=129; //
      if(l1u==196) l1u=142; //
      if(l1u==214) l1u=153; //
      if(l1u==220) l1u=154; //
      if(l1u==223) l1u=225; //
      printf("%c", l1u);
  }
  
  printf("\n\n%s\t%d\n\n%s","Anzahl aller Doppelzeichen im Text:",nchcb,"Zur Ausgabe der unsortierten Doppel-Zeichen: ");
  
  // Haltepunkt fr Bildschirmausgabe:
  system("Pause");
  
  // Zhlung der Doppel-Zeichen:
  
  for (i=0;i<nchcb;i++)
  {
      sum=0;
      for(j=0;j<ntxt/2;j++) if ((chcb[2*i]==txt[2*j]) && (chcb[2*i+1]==txt[2*j+1])) sum++;
      sum_zeichenb[i]=sum;
  }
  sum=0;
  
  printf("\n%s\n","Unsortierte Liste der Hufigkeiten und Wahrsheinlichkeiten:");
  
  for (i=0;i<nchcb;i++)
  {
      l1u= chcb[2*i]; l2u=chcb[2*i+1];
      if(l1u==228) l1u=132; //
      if(l2u==228) l2u=132; //
      if(l1u==246) l1u=148; //
      if(l2u==246) l2u=148; //
      if(l1u==252) l1u=129; //
      if(l2u==252) l2u=129; //
      if(l1u==196) l1u=142; //
      if(l2u==196) l2u=142; //
      if(l1u==214) l1u=153; //
      if(l2u==214) l2u=153; //
      if(l1u==220) l1u=154; //
      if(l2u==220) l2u=154; //
      if(l1u==223) l1u=225; //
      if(l2u==223) l2u=225; //
      printf("\n%d\t%c%c\t%d\t%2.6f",i,l1u,l2u,sum_zeichenb[i],((float) sum_zeichenb[i]/(float) (ntxt/2)));
      sum=sum+2*sum_zeichenb[i];
  }
  printf("\n\n%s","Zur Kontrollausgabe der Zeichenanzahlen: ");
  // Kontrollpunkt fr Bildschirmausgabe
  
  system("Pause");
  
  // Kontrollausgabe der Zeichenanzahl im Vergleich:
                     
  printf("\n\%s%d\%s%d\n","Anzahl der Textzeichen und Summe der Hufigkeiten * 2: ",ntxt, " und ",sum);
  
  // Kopieren in Hilfsfelder:
      
  for (i=0;i<nchcb;i++) {chcb_hilf[2*i]= chcb[2*i]; chcb_hilf[2*i+1]= chcb[2*i+1];} 
  for (i=0;i<nchcb;i++) {fb_hilf[2*i]= sum_zeichenb[2*i]; fb_hilf[2*i+1]= sum_zeichenb[2*i+1];}
      
  // Sortieren nach fallenden Hufigkeiten
     
  ia=0;
  while (ia < nchcb)
  {
      iha=0;
      ih=fb_hilf[ia];
      b[0]=chcb_hilf[2*ia]; b[1]=chcb_hilf[2*ia+1];
      for (j=ia+1;j<nchcb;j++) if (ih<fb_hilf[j])  iha=j;
      if (iha != 0)
      {
         for (k=ia;k<iha;k++) {fb_hilf[k]=fb_hilf[k+1]; chcb_hilf[2*k]=chcb_hilf[2*k+2]; chcb_hilf[2*k+1]=chcb_hilf[2*k+3];}
         fb_hilf[iha]=ih;
         chcb_hilf[2*iha]=b[0];
         chcb_hilf[2*iha+1]=b[1];
      } 
      else ia=ia+1;
   }
   
   printf("\n\n%s","Zur Ausgabe der sortierten Doppelzeichen: ");
   system("Pause");
   // Ausgabe der sortierten Liste der Doppel-Zeichen mit Hufikeiten und Wahrscheinlichkeiten
   
   printf("\n\n%s\n","Sortierte Liste der Doppelzeichen nach fallenden Hufigkeiten:");
    
   for (i=0;i<nchcb;i++) 
   {
       l1u= chcb_hilf[2*i]; l2u=chcb_hilf[2*i+1];
       if(l1u==228) l1u=132; //
       if(l2u==228) l2u=132; //
       if(l1u==246) l1u=148; //
       if(l2u==246) l2u=148; //
       if(l1u==252) l1u=129; //
       if(l2u==252) l2u=129; //
       if(l1u==196) l1u=142; //
       if(l2u==196) l2u=142; //
       if(l1u==214) l1u=153; //
       if(l2u==214) l2u=153; //
       if(l1u==220) l1u=154; //
       if(l2u==220) l2u=154; //
       if(l1u==223) l1u=225; //
       if(l2u==223) l2u=225; //
       printf("\n%d\t%c%c\t%d\t%2.6f",i,l1u,l2u,fb_hilf[i],((float) fb_hilf[i]/(float) (ntxt/2)));
   }
   
   // Das Ergebnis kann z. B. zum Aufbau eines Huffman-Binrbaumes dienen
   
   printf("\n\n%s", "Zum Beenden: "); 
   system("PAUSE");
}

